<CsoundSynthesizer>

<CsOptions>
-W -o PhISEM_dripwater.wav 
</CsOptions>

<CsScore>
; Head of the .sco file - typically the section up to the first i  instruction.
;
; Sometimes however i instructions for initialisation isntruments are needed - you can spot those
; as they will have different instrument numbers and be used only
; at the head of the file. These need to be included here and
; need to be done with #s before the instrument
; number, e.g. i#1 etc.

;
; Number tables with # as f#5 etc, which will be replaced by a
; unique table number for the instrument when placed in the orchestra.
;
; You can also add any i instruction for set up type instruments here
; - such as an instrument to set up a drum so that it can be struck later.
; by the drum stick instrument, when the notes are played.
; They will need #s as well.
</CsScore>

<CsInstrumentToPlay>
; AMP or DB or VEL (for midi velocity) for amplitude parameters
;
; CPS, PCH, OCT, MIDI or  eg. PCH31 (for 31-et notation) for frequency parameters
;These can also be used in formulae e.g. CPS/10. Do the formulae with no spaces
;
;Prefix function tables numbers with F so that they can be incremented

AMP 0.01 10 80   0.3 CPS CPS*12/9 CPS*5/3 5
; Duration, number of objects, damping factor range (percent, suggested 70 to 87.5), energy to feed back range 0 to 1, main resonant frequency, first resonant frequency, second resonant frequency, amplitude boost. Amplitude is randomised
</CsInstrumentToPlay>

<CsInstruments>
; Enter the actual instrument here, - the section from instr to endin.
; Leave out the section at the head
; giving the number of channels for the output. This gets
; made by the calling program.
;
; The instrument number here is ignored, can be anything, so you don't need to change that.
;
; Function table numbers from the .SCO section need to be shown
; here as #1 #2 etc. so that they can be incremented.
;
; If you have extra initialisation instruments needed for the head of
; the SCO file, then use #1, #2 etc as their instrument numbers
; so that they also can be incremented to match the numbers in the
;  [SCO] section.

instr 1  

kamp = p4
idettack = p5 ;period of time over which all sound is stopped 
inum = p6 ; The number of beads, teeth, bells, timbrels, etc. If zero, the default value is 1.25. 
idamp = p7/200 ; the damping factor range 0 to 1.9. Suggested range 1.4 to 1.75
imaxshake = p8 ; amount of energy to add back into the system. The value should be in range 0 to 1
ifreq = p9 ; the main resonant frequency. The default value is 450
ifreq1 = p10 ; the first resonant frequency. The default value is 600. 
ifreq2 = p11 ; the second resonant frequency. The default value is 750
iboost = p12

a2 dripwater kamp, idettack , inum, idamp, imaxshake, ifreq, ifreq1, ifreq2
    out a2*iboost 
    endin
</CsInstruments>

</CsoundSynthesizer>
