/////////////////////////////////////////////////////////////////////////////
// FTS_MFXPropPage.cpp : implementation file
//
// This file provides the implemention of the property page (user interface)
// for "Fractal Tune Smithy."
//

#include "stdafx.h"
#include <MidiFilter.h>
#include "FTS_MFX.h"
#include "FTS_MFXPropPage.h"
#include "externs.h"
HWND g_hDlgPropPage;
extern char do_all_sound_off;
/////////////////////////////////////////////////////////////////////////////
//
// CFTS_MFXPropPage dialog
//
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructors

CFTS_MFXPropPage::CFTS_MFXPropPage(CWnd* pParent /*=NULL*/)
: CDialog(CFTS_MFXPropPage::IDD, pParent),
	m_cRef( 1 ),
	m_pFilter( NULL ),
	m_pPageSite( NULL ),
	m_bDirty( FALSE )
{
	//{{AFX_DATA_INIT(CFTS_MFXPropPage)
	m_bypass_fts = FALSE;
 m_fts_raw_data=TRUE;
	m_fts_notes = TRUE;
	m_fts_controllers = TRUE;
	m_fts_pitch_bends = TRUE;
	m_fts_aftertouch = FALSE;
	m_fts_patches = TRUE;
 m_fts_midi_in_data=TRUE;
	m_fts_send_on_if_not_processed = FALSE;
	m_fts_mute = FALSE;
	m_fts_log_to_text = FALSE;
	m_fts_mute_midi_in = FALSE;
	m_fts_skip_all_controllers = FALSE;
	m_fts_channel_to_relay = 1;
	m_fts_choose_channel_to_relay = FALSE;
	m_fts_relay_to_same_chann = FALSE;
	m_fts_process_all_channels_up_to = FALSE;
	m_fts_channel_to_process_up_to = 16;
	m_fts_verbose_log = FALSE;
	m_fts_pitch_bend_delay = 1;
	m_fts_do_pitch_bend_delay = FALSE;
	m_do_resets = FALSE;
	m_do_resets_again = FALSE;
	//}}AFX_DATA_INIT
}

/////////////////////////////////////////////////////////////////////////////
void UpdateChecks(void)
{
 static char in_this;
 if(in_this)
  return;
 in_this=1;
 if(!prop.initialised)
 {
  prop.do_resets=FALSE;
  prop.do_resets_again=FALSE;
	 prop.bypass_fts = FALSE;
  prop.fts_raw_data=TRUE;
	 prop.fts_notes = TRUE;
	 prop.fts_controllers = TRUE;
	 prop.fts_pitch_bends = TRUE;
	 prop.fts_aftertouch = FALSE;
	 prop.fts_patches = TRUE;
  prop.fts_midi_in_data=TRUE;
	 prop.fts_send_on_if_not_processed = FALSE;
	 prop.fts_mute = FALSE;
	 prop.fts_log_to_text = FALSE;
	 prop.fts_mute_midi_in = FALSE;
	 prop.fts_skip_all_controllers = FALSE;
	 prop.fts_do_pitch_bend_delay = FALSE;
	 prop.fts_pitch_bend_delay = 1;
	 prop.fts_channel_to_relay = 1;
	 prop.fts_choose_channel_to_relay = FALSE;
	 prop.fts_relay_to_same_chann = FALSE;
	 prop.fts_process_all_channels_up_to = FALSE;
	 prop.fts_channel_to_process_up_to = 16;
	 prop.fts_verbose_log = FALSE;
	 prop.fts_do_pitch_bend_delay = FALSE;
 }
 prop.initialised=TRUE;
 DECLARE_LOCAL(bypass_fts)
 DECLARE_LOCAL(fts_aftertouch)
 DECLARE_LOCAL(fts_controllers)
 DECLARE_LOCAL(fts_pitch_bends)
 DECLARE_LOCAL(fts_patches)
 DECLARE_LOCAL(fts_notes)
 DECLARE_LOCAL(fts_raw_data)
 DECLARE_LOCAL(fts_send_on_if_not_processed)
 DECLARE_LOCAL(fts_mute)
 DECLARE_LOCAL(fts_log_to_text)
 DECLARE_LOCAL(fts_mute_midi_in)
 DECLARE_LOCAL(fts_midi_in_data)
 DECLARE_LOCAL(fts_relay_to_same_chann)
 DECLARE_LOCAL(fts_choose_channel_to_relay)
 DECLARE_LOCAL_INT(fts_pitch_bend_delay)
 DECLARE_LOCAL_INT(fts_channel_to_relay)
 DECLARE_LOCAL(fts_process_all_channels_up_to)
 DECLARE_LOCAL_INT(fts_channel_to_process_up_to)
 DECLARE_LOCAL(fts_verbose_log)
 DECLARE_LOCAL(fts_do_pitch_bend_delay)
 DECLARE_LOCAL(do_resets)
 DECLARE_LOCAL(do_resets_again)
 
 char fts_processing_enabled=bypass_fts||fts_mute?0:1;
 /**
 {
  char sz[STRMAX];
  sprintf(sz,"%d",prop.fts_channel_to_process_up_to);
  SetDlgItemText(g_hDlgPropPage,IDC_EDIT_CHANNEL_TO_PROCESS_UP_TO,sz);
  sprintf(sz,"%d",prop.fts_channel_to_relay);
  SetDlgItemText(g_hDlgPropPage,IDC_EDIT_CHANNEL_TO_RELAY,sz);
 }
 **/
 if(fts_midi_in_data&&!fts_mute_midi_in)
  fts_processing_enabled=1;
#define SET_CHECK_STATE(idc,var)   CheckDlgButton(g_hDlgPropPage,idc,var?BST_CHECKED:BST_UNCHECKED)
#define SET_ENABLED_STATE(idc,var)   EnableWindow(GetDlgItem(g_hDlgPropPage,idc),var?BST_CHECKED:BST_UNCHECKED)

	SET_ENABLED_STATE(IDC_CHECK_SKIP_ALL_CONTROLLERS,fts_processing_enabled/*fts_raw_data*/);
	SET_ENABLED_STATE(IDC_CHECK_RAW_DATA,fts_processing_enabled/*fts_raw_data*/);
	SET_ENABLED_STATE(IDC_CHECK_NOTES,fts_processing_enabled/*fts_notes*/);
	SET_ENABLED_STATE(IDC_CHECK_CONTROLLERS,fts_processing_enabled/*fts_controllers*/);
	SET_ENABLED_STATE(IDC_CHECK_PITCH_BENDS,fts_processing_enabled/*fts_pitch_bends*/);
	SET_ENABLED_STATE(IDC_CHECK_AFTERTOUCH,fts_processing_enabled/*fts_aftertouch*/);
	SET_ENABLED_STATE(IDC_CHECK_PATCHES,fts_processing_enabled/*fts_patches*/);
	SET_ENABLED_STATE(IDC_CHECK_SEND_ON_IF_NOT_PROCESSED,fts_processing_enabled/*fts_send_on_if_not_processed*/);
	// SET_ENABLED_STATE(IDC_CHECK_LOG,fts_processing_enabled/*fts_log_to_text*/);	
	SET_ENABLED_STATE(IDC_CHECK_MUTE_MIDI_IN_RELAY,fts_midi_in_data/*fts_log_to_text*/);	
	SET_ENABLED_STATE(IDC_CHECK_PROCESS_ALL_CHANNELS_UP_TO,fts_processing_enabled);
	SET_ENABLED_STATE(IDC_CHECK_CHOOSE_A_CHANNEL_TO_RELAY,fts_processing_enabled);
	SET_ENABLED_STATE(IDC_CHECK_RELAY_TO_SAME_CHANN,fts_processing_enabled);
	SET_ENABLED_STATE(IDC_CHECK_PATCHES,fts_processing_enabled);
	SET_ENABLED_STATE(IDC_EDIT_CHANNEL_TO_PROCESS_UP_TO,fts_processing_enabled);
	SET_ENABLED_STATE(IDC_EDIT_CHANNEL_TO_RELAY,fts_processing_enabled&&fts_choose_channel_to_relay);
	SET_ENABLED_STATE(IDC_EDIT_PITCH_BEND_DELAY,fts_processing_enabled&&fts_do_pitch_bend_delay);
	SET_CHECK_STATE(IDC_CHECK_MUTE, fts_mute);
 SET_CHECK_STATE(IDC_CHECK_BYPASS, bypass_fts);
	SET_CHECK_STATE(IDC_CHECK_NOTES, fts_notes);
	SET_CHECK_STATE(IDC_CHECK_CONTROLLERS, fts_controllers);
	SET_CHECK_STATE(IDC_CHECK_PATCHES, fts_patches);
	SET_CHECK_STATE(IDC_CHECK_PITCH_BENDS, fts_pitch_bends);
	SET_CHECK_STATE(IDC_CHECK_AFTERTOUCH, fts_aftertouch);
	SET_CHECK_STATE(IDC_CHECK_RAW_DATA, fts_raw_data);
	SET_CHECK_STATE(IDC_CHECK_LOG, fts_log_to_text);
	SET_CHECK_STATE(IDC_CHECK_SEND_ON_IF_NOT_PROCESSED, fts_send_on_if_not_processed);
	SET_CHECK_STATE(IDC_CHECK_VERBOSE_LOG, fts_verbose_log);
	SET_CHECK_STATE(IDC_CHECK_DO_PITCH_BEND_DELAY, fts_do_pitch_bend_delay);
	SET_CHECK_STATE(IDC_CHECK_MIDI_IN_RELAY, fts_midi_in_data);
	SET_CHECK_STATE(IDC_CHECK_PROCESS_ALL_CHANNELS_UP_TO,fts_process_all_channels_up_to);

	SET_CHECK_STATE(IDC_CHECK_PROCESS_ALL_CHANNELS_RETUNE_TO_ANY_CHANNEL,fts_choose_channel_to_relay==0&&fts_relay_to_same_chann==0);
	SET_CHECK_STATE(IDC_CHECK_CHOOSE_A_CHANNEL_TO_RELAY,fts_choose_channel_to_relay);
	SET_CHECK_STATE(IDC_CHECK_RELAY_TO_SAME_CHANN,fts_relay_to_same_chann);
	SET_CHECK_STATE(IDC_CHECK_DO_RESETS,do_resets);
	SET_CHECK_STATE(IDC_CHECK_DO_RESETS_AGAIN,do_resets_again);
 {
  char sz[STRMAX];
  sprintf(sz,"%d",fts_pitch_bend_delay);
  SetDlgItemText(g_hDlgPropPage,IDC_EDIT_PITCH_BEND_DELAY,sz);
 }
 {
  char sz[STRMAX];
  sprintf(sz,"%d",fts_channel_to_relay);
  SetDlgItemText(g_hDlgPropPage,IDC_EDIT_CHANNEL_TO_RELAY,sz);
 }
 
 in_this=0;
}
void ShowWindowFor(WORD idc)
{
 HWND hwndChild=GetDlgItem(g_hDlgPropPage,idc);
 if(hwndChild)
 ShowWindow(hwndChild,SW_SHOWNORMAL);
}
void 	ShowChildWindows()
{
 ShowWindowFor(IDC_SPIN_CHANNEL_TO_RELAY);
 ShowWindowFor(IDC_STATIC1);
 ShowWindowFor(IDC_BUTTON_SHOW_HELP);
 ShowWindowFor(IDC_BUTTON_SHOW_LOG);
 ShowWindowFor(IDC_BUTTON_TEST_PITCH_BEND_RANGE);
 ShowWindowFor(IDC_CHECK_SKIP_ALL_CONTROLLERS);
 ShowWindowFor(IDC_CHECK_PATCHES);
 // ShowWindowFor(IDC_EDIT_CHANNEL_TO_PROCESS_UP_TO);
 ShowWindowFor(IDC_EDIT_CHANNEL_TO_RELAY);
 ShowWindowFor(IDC_CHECK_MUTE);
 ShowWindowFor(IDC_CHECK_BYPASS);
 ShowWindowFor(IDC_CHECK_NOTES);
 ShowWindowFor(IDC_CHECK_CONTROLLERS);
 ShowWindowFor(IDC_CHECK_PATCHES);
 ShowWindowFor(IDC_CHECK_PITCH_BENDS);
 ShowWindowFor(IDC_CHECK_AFTERTOUCH);
 ShowWindowFor(IDC_CHECK_AFTERTOUCH);
 ShowWindowFor(IDC_CHECK_RAW_DATA);
 ShowWindowFor(IDC_CHECK_LOG);
 ShowWindowFor(IDC_CHECK_SEND_ON_IF_NOT_PROCESSED);
 ShowWindowFor(IDC_CHECK_VERBOSE_LOG);
 ShowWindowFor(IDC_CHECK_DO_PITCH_BEND_DELAY);
 ShowWindowFor(IDC_EDIT_PITCH_BEND_DELAY);
 ShowWindowFor(IDC_VSCROLL_PITCH_BEND_DELAY);
 ShowWindowFor(IDC_STATIC_PITCH_BEND_DELAY);
 ShowWindowFor(IDC_CHECK_MIDI_IN_RELAY);
 // ShowWindowFor(IDC_CHECK_PROCESS_ALL_CHANNELS_UP_TO);
 ShowWindowFor(IDC_CHECK_CHOOSE_A_CHANNEL_TO_RELAY);
 ShowWindowFor(IDC_CHECK_RELAY_TO_SAME_CHANN);
#ifdef cl_do_resets
 ShowWindowFor(IDC_CHECK_DO_RESETS);
 ShowWindowFor(IDC_CHECK_DO_RESETS_AGAIN);
#endif
}

void CFTS_MFXPropPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFTS_MFXPropPage)
	DDX_Control(pDX, IDC_SPIN_CHANNEL_TO_RELAY, m_SpinChannelToRelay);
	DDX_Control(pDX, IDC_SPIN_CHANNEL_TO_PROCESS_UP_TO, m_SpinChannelToProcessUpTo);
 DDX_Check(pDX, IDC_CHECK_BYPASS, m_bypass_fts);
	DDX_Check(pDX, IDC_CHECK_RAW_DATA, m_fts_raw_data);
	DDX_Check(pDX, IDC_CHECK_NOTES, m_fts_notes);
	DDX_Check(pDX, IDC_CHECK_CONTROLLERS, m_fts_controllers);
	DDX_Check(pDX, IDC_CHECK_PITCH_BENDS, m_fts_pitch_bends);
	DDX_Check(pDX, IDC_CHECK_AFTERTOUCH, m_fts_aftertouch);
	DDX_Check(pDX, IDC_CHECK_PATCHES, m_fts_patches);
	DDX_Check(pDX, IDC_CHECK_MIDI_IN_RELAY, m_fts_midi_in_data);
	DDX_Check(pDX, IDC_CHECK_SEND_ON_IF_NOT_PROCESSED, m_fts_send_on_if_not_processed);
	DDX_Check(pDX, IDC_CHECK_MUTE, m_fts_mute);
	DDX_Check(pDX, IDC_CHECK_LOG, m_fts_log_to_text);
	DDX_Check(pDX, IDC_CHECK_MUTE_MIDI_IN_RELAY, m_fts_mute_midi_in);
	DDX_Check(pDX, IDC_CHECK_SKIP_ALL_CONTROLLERS, m_fts_skip_all_controllers);
	DDX_Text(pDX, IDC_EDIT_CHANNEL_TO_RELAY, m_fts_channel_to_relay);
	DDX_Check(pDX, IDC_CHECK_CHOOSE_A_CHANNEL_TO_RELAY, m_fts_choose_channel_to_relay);
	DDX_Check(pDX, IDC_CHECK_RELAY_TO_SAME_CHANN, m_fts_relay_to_same_chann);
	DDX_Check(pDX, IDC_CHECK_PROCESS_ALL_CHANNELS_UP_TO, m_fts_process_all_channels_up_to);
	DDX_Text(pDX, IDC_EDIT_CHANNEL_TO_PROCESS_UP_TO, m_fts_channel_to_process_up_to);
	DDX_Check(pDX, IDC_CHECK_VERBOSE_LOG, m_fts_verbose_log);
	DDX_Text(pDX, IDC_EDIT_PITCH_BEND_DELAY, m_fts_pitch_bend_delay);
	DDX_Check(pDX, IDC_CHECK_DO_PITCH_BEND_DELAY, m_fts_do_pitch_bend_delay);
	DDX_Check(pDX, IDC_CHECK_DO_RESETS, m_do_resets);
	DDX_Check(pDX, IDC_CHECK_DO_RESETS_AGAIN, m_do_resets_again);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CFTS_MFXPropPage, CDialog)
	//{{AFX_MSG_MAP(CFTS_MFXPropPage)
	ON_BN_CLICKED(IDC_CHECK_BYPASS, OnCheckBypass)
	ON_BN_CLICKED(IDC_CHECK_RAW_DATA, OnCheckRawData)
	ON_BN_CLICKED(IDC_CHECK_NOTES, OnCheckNoteOns)
	ON_BN_CLICKED(IDC_CHECK_CONTROLLERS, OnCheckControllers)
	ON_BN_CLICKED(IDC_CHECK_PITCH_BENDS, OnCheckPitchBends)
	ON_BN_CLICKED(IDC_CHECK_AFTERTOUCH, OnCheckAftertouch)
	ON_BN_CLICKED(IDC_CHECK_PATCHES, OnCheckPatches)
	ON_BN_CLICKED(IDC_CHECK_MIDI_IN_RELAY, OnCheckMidiInData)
	ON_BN_CLICKED(IDC_CHECK_SEND_ON_IF_NOT_PROCESSED, OnCheckSendOnIfNotProcessed)
	ON_BN_CLICKED(IDC_CHECK_MUTE, OnCheckMute)
	ON_BN_CLICKED(IDC_CHECK_LOG, OnCheckLogToText)
	ON_BN_CLICKED(IDC_CHECK_MUTE_MIDI_IN_RELAY, OnCheckMuteMidiIn)
	ON_BN_CLICKED(IDC_BUTTON_SHOW_LOG, OnShowLog)
	ON_BN_CLICKED(IDC_CHECK_SKIP_ALL_CONTROLLERS, OnCheckSkipAllFTSControllers)
	ON_EN_CHANGE(IDC_EDIT_CHANNEL_TO_RELAY, OnChangeEditChannelToRelay)
	ON_BN_CLICKED(IDC_CHECK_RELAY_FIRST_CHANN_WITH_NOTES, OnCheckProcessAllChannelsUpToChann)
	ON_BN_CLICKED(IDC_CHECK_CHOOSE_A_CHANNEL_TO_RELAY, OnCheckChooseChannelToRelay)
	ON_BN_CLICKED(IDC_CHECK_RELAY_NOTES_TO_SAME_CHANNEL, OnCheckRelayToSameChann)
	ON_EN_CHANGE(IDC_EDIT_CHANNEL_TO_PROCESS_UP_TO, OnChangeEditChannelToProcessUpTo)
	ON_BN_CLICKED(IDC_CHECK_VERBOSE_LOG, OnCheckVerboseLog)
	ON_BN_CLICKED(IDC_BUTTON_SHOW_HELP, OnButtonShowHelp)
	ON_BN_CLICKED(IDC_CHECK_DO_RESETS, OnCheckDoResets)
	ON_EN_CHANGE(IDC_EDIT_PITCH_BEND_DELAY, OnChangeEditPitchBendDelay)
	ON_BN_CLICKED(IDC_CHECK_DO_PITCH_BEND_DELAY, OnCheckDoPitchBendDelay)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_CHANNEL_TO_RELAY, OnDeltaposSpinChannelToRelay)
	ON_NOTIFY(UDN_DELTAPOS, IDC_VSCROLL_PITCH_BEND_DELAY, OnDeltaposVscrollPitchBendDelay)
	ON_BN_CLICKED(IDC_CHECK_DO_RESETS_AGAIN, OnCheckDoResetsAgain)
	ON_BN_CLICKED(IDC_BUTTON_TEST_PITCH_BEND_RANGE, OnButtonTestPitchBendRange)
	ON_BN_CLICKED(IDC_BUTTON_ALL_SOUND_OFF, OnButtonAllSoundOff)
	ON_BN_CLICKED(IDC_CHECK_PROCESS_ALL_CHANNELS_RETUNE_TO_ANY_CHANNEL, OnCheckProcessAllChannelsRetuneToAnyChannel)
	ON_BN_CLICKED(IDC_CHECK_RELAY_TO_SAME_CHANN, OnCheckRelayToSameChann)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////

CFTS_MFXPropPage::~CFTS_MFXPropPage()
{
}

////////////////////////////////////////////////////////////////////////////////
// IPropertyPage Implementation
//
// You may add to the following IPropertyPage methods as you wish.  However, it may
// be useful to realize that each of these methods has been completed to a necessary level 
// of functionality, and that you are therefore not required to make any modifications 
// to the existing code.

BOOL CALLBACK CFTS_MFXPropPage::DialogProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	// This proc is only a dummy. It's necessary to to get the size of the dialog
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::SetObjects( ULONG cObjects, LPUNKNOWN* ppUnk )
{
	if (cObjects == 1)
	{
		// Validate arguments
		if (ppUnk == NULL || *ppUnk == NULL)
			return E_POINTER;

		// Cast this to be our type
		CFTS_MFX* const pFilter = reinterpret_cast<CFTS_MFX*>(*ppUnk);
		
		// If different than previous object, release the old one
		if (m_pFilter != pFilter && m_pFilter != NULL)
			m_pFilter->Release();

		m_pFilter = pFilter;
		m_pFilter->AddRef();

		return S_OK;
	}
	else if (cObjects == 0)
	{
		if (m_pFilter == NULL)
			return E_UNEXPECTED;

		m_pFilter->Release();
		m_pFilter = NULL;

		return S_OK;
	}
	else
		return E_UNEXPECTED;
}

////////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::Activate( HWND hwndParent, LPCRECT pRect, BOOL fModal )
{
	if (!pRect)
		return E_POINTER;
	if (NULL != m_hWnd)
		return E_UNEXPECTED;	// already active!

	if (!CreateMFCDialog( hwndParent ))
		return E_OUTOFMEMORY;
 g_hDlgPropPage=m_hWnd;
	// Parent should control us so the user can tab out of property page
	DWORD dwStyle = GetWindowLong( m_hWnd, GWL_EXSTYLE );
	dwStyle = dwStyle | WS_EX_CONTROLPARENT;
	SetWindowLong( m_hWnd, GWL_EXSTYLE, dwStyle );

	// Move page into position and show it.
	ShowChildWindows();
 UpdateChecks();
 m_SpinChannelToProcessUpTo.SetRange(1,16);
 m_SpinChannelToRelay.SetRange(1,16);
#define SET_PROP(var) prop.var=m_##var;
 SET_PROP(bypass_fts)
 SET_PROP(fts_aftertouch)
 SET_PROP(fts_controllers)
 SET_PROP(fts_pitch_bends)
 SET_PROP(fts_patches)
 SET_PROP(fts_notes)
 SET_PROP(fts_raw_data)
 SET_PROP(fts_send_on_if_not_processed)
 SET_PROP(fts_mute)
 SET_PROP(fts_log_to_text)
 SET_PROP(fts_midi_in_data)
 SET_PROP(fts_mute_midi_in)
 SET_PROP(fts_skip_all_controllers)
 SET_PROP(fts_pitch_bend_delay)
 SET_PROP(fts_channel_to_relay)
 SET_PROP(fts_process_all_channels_up_to)
 SET_PROP(fts_channel_to_process_up_to)
 SET_PROP(fts_choose_channel_to_relay)
 SET_PROP(fts_relay_to_same_chann)
 g_hDlgPropPage=m_hWnd;
	Move( pRect );
	Show( SW_SHOWNORMAL );
	return S_OK;
}

////////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::Move( LPCRECT pRect )
{
	if (!pRect)
		return E_POINTER;
	if (NULL == m_hWnd)
		E_UNEXPECTED;

	MoveWindow( pRect->left, pRect->top, pRect->right - pRect->left, pRect->bottom - pRect->top, TRUE );

	return S_OK;
}

////////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::Show( UINT nCmdShow )
{
	if (NULL == m_hWnd)
		return E_UNEXPECTED;
	// Ignore wrong show flags
	if (nCmdShow != SW_SHOW && nCmdShow != SW_SHOWNORMAL && nCmdShow != SW_HIDE)
		return E_INVALIDARG;
	ShowWindow( nCmdShow );


	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::Deactivate()
{
	if (NULL == m_hWnd)
		return E_UNEXPECTED;

	DestroyMFCDialog();
	return S_OK;
}

////////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::SetPageSite( LPPROPERTYPAGESITE pPageSite )
{
	if (pPageSite)
	{
		if (m_pPageSite)
			return E_UNEXPECTED;
		m_pPageSite = pPageSite;
		m_pPageSite->AddRef();
	}
	else
	{
		if (m_pPageSite == NULL)
			return E_UNEXPECTED;
		m_pPageSite->Release();
		m_pPageSite = NULL;
	}
	return S_OK;
}

////////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::Apply()
{
	// Take no action except clearing the dirty flag.
	// So that the property page may be used in realtime, all user interface
	// changes are immediately passed to the filter. I.e. there is no Cancel.
	m_bDirty = FALSE;
	return S_OK;
}

////////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::IsPageDirty()
{
	return m_bDirty ? S_OK : S_FALSE;
}
/////////////////////////////////////////////////////////////////////////////

HRESULT ShowHelp(void)
{
 char szUrl[MAX_PATH];
 char szDllPath[MAX_PATH];
 GetModulePath(szDllPath,MAX_PATH,"fts_mfx.dll");
 MakePathFile(szUrl,szDllPath,"mfx.htm");
#ifdef _DEBUG
 MakePathFile(szUrl,"L:\\_fts_source\\help","mfx.htm");
 {
  char szmsg[STRMAX+MAX_PATH];
  sprintf(szmsg,"Show help url %s\n\nDll location %s"
         ,szUrl,szDllPath
         );
  MessageBox(g_hDlgPropPage,szmsg,"debug",0);
 }
#endif
 if(ShowUrlInBrowserWithDefaultErrorMessage(szUrl))
  return S_OK;
 else
	 return E_FAIL;
	// return E_NOTIMPL;
}

HRESULT CFTS_MFXPropPage::Help( LPCWSTR lpszHelpDir )
{
 return ShowHelp();
}

/////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::TranslateAccelerator( LPMSG lpMsg )
{
	return E_NOTIMPL;
}

/////////////////////////////////////////////////////////////////////////////

HRESULT CFTS_MFXPropPage::GetPageInfo( LPPROPPAGEINFO pPageInfo )
{
	IMalloc* pIMalloc;
	if (FAILED( CoGetMalloc( MEMCTX_TASK, &pIMalloc ) ))
		return E_FAIL;

	pPageInfo->pszTitle = (LPOLESTR)pIMalloc->Alloc( 256 );

	pIMalloc->Release();

	if (!pPageInfo->pszTitle)
		return E_OUTOFMEMORY;

	static const char szTitle[] = "Fractal Tune Smithy";
	mbstowcs( pPageInfo->pszTitle, szTitle, strlen( szTitle ) );

	// Populate the page info structure
	pPageInfo->cb					= sizeof(PROPPAGEINFO);
	pPageInfo->size.cx      = 100;
	pPageInfo->size.cy      = 100;
	pPageInfo->pszDocString = NULL;
	pPageInfo->pszHelpFile  = NULL;
	pPageInfo->dwHelpContext= 0;

	// Create the property page in order to determine its size
	HWND const hWnd = CreateDialogParam( theApp.m_hInstance, MAKEINTRESOURCE( IDD_PROPPAGE ), 
													 ::GetDesktopWindow(), DialogProc, 0 );
	if (hWnd)
	{
		// Get the dialog size and destroy the window
		RECT rc;
		::GetWindowRect( hWnd, &rc );
		pPageInfo->size.cx = rc.right - rc.left;
		pPageInfo->size.cy = rc.bottom - rc.top;
		::DestroyWindow( hWnd );
	}

	return S_OK;
}

////////////////////////////////////////////////////////////////////////////////
// End of IPropertyPage Implementation
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class Wizard will add additional methods here.
//



void CFTS_MFXPropPage::OnCheckNoteOns() 
{
#define TOGGLE_AND_SET_PROP(var) \
 {\
 m_##var=m_##var?0:1;\
  prop.var=m_##var;\
  log_header_up_to_date=0;\
 }
 TOGGLE_AND_SET_PROP(fts_notes);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckControllers() 
{
 TOGGLE_AND_SET_PROP(fts_controllers);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckAftertouch() 
{
 TOGGLE_AND_SET_PROP(fts_aftertouch);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckBypass() 
{
 TOGGLE_AND_SET_PROP(bypass_fts);
 if(m_bypass_fts)
  m_fts_mute=prop.fts_mute=0;
 UpdateChecks();
}

void CFTS_MFXPropPage::OnCheckPitchBends() 
{
 TOGGLE_AND_SET_PROP(fts_pitch_bends);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckPatches() 
{
 TOGGLE_AND_SET_PROP(fts_patches);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckRawData() 
{
 TOGGLE_AND_SET_PROP(fts_raw_data);
 UpdateChecks();	
	
}

void CFTS_MFXPropPage::OnCheckMidiInData() 
{
 TOGGLE_AND_SET_PROP(fts_midi_in_data);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckSendOnIfNotProcessed() 
{
 TOGGLE_AND_SET_PROP(fts_send_on_if_not_processed);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckMute() 
{
 TOGGLE_AND_SET_PROP(fts_mute);
 if(m_fts_mute)
  m_bypass_fts=prop.bypass_fts=0;
 UpdateChecks();
	// TODO: Add your control notification handler code here
	
}

extern char started_log,log_header_up_to_date;
void CFTS_MFXPropPage::OnCheckLogToText() 
{
	// TODO: Add your control notification handler code here
 TOGGLE_AND_SET_PROP(fts_log_to_text);
 if(prop.fts_log_to_text)
 started_log=log_header_up_to_date=0;
 UpdateChecks();	
}


void CFTS_MFXPropPage::OnCheckMuteMidiIn() 
{
 TOGGLE_AND_SET_PROP(fts_mute_midi_in);
 UpdateChecks();	
	// TODO: Add your control notification handler code here
	
}

#define ShowTextFile(szPFile,szFile,szCaption,sztype)\
 ShowFileForExtension(szPFile,szFile,szCaption,sztype,"text file",".txt",".txt")

void CFTS_MFXPropPage::OnShowLog() 
{
 char szLogPFile[MAX_PATH];
 char szDllPath[MAX_PATH];
 GetModulePath(szDllPath,MAX_PATH,"fts_mfx");
 MakePathFile(szLogPFile,szDllPath,"messages\\mfx_log.txt");
 MakeAnyNewWindowsFolders(szLogPFile);
 ShowTextFile(szLogPFile,"mfx_log.txt","Show Log","Log to text file: ");	
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckSkipAllFTSControllers() 
{
 TOGGLE_AND_SET_PROP(fts_skip_all_controllers);	
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnChangeEditChannelToRelay() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
#define MAX_MIDI_CHANNELS 16
 {
  char sz[STRMAX];
  GetDlgItemText(IDC_EDIT_CHANNEL_TO_RELAY,sz,STRMAX);
  m_fts_channel_to_relay=atoi(sz);
 }
 prop.fts_channel_to_relay=m_fts_channel_to_relay;
 // UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckProcessAllChannelsUpToChann() 
{
 TOGGLE_AND_SET_PROP(fts_process_all_channels_up_to);	
 UpdateChecks();	
	
}

void CFTS_MFXPropPage::OnCheckChooseChannelToRelay() 
{
	m_fts_choose_channel_to_relay=prop.fts_choose_channel_to_relay=1;
// TOGGLE_AND_SET_PROP(fts_choose_channel_to_relay);	
 if(m_fts_choose_channel_to_relay)
  m_fts_relay_to_same_chann=prop.fts_relay_to_same_chann=0;
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckRelayToSameChann() 
{
	m_fts_relay_to_same_chann=prop.fts_relay_to_same_chann=1;
// TOGGLE_AND_SET_PROP(fts_relay_to_same_chann);	
 if(m_fts_relay_to_same_chann)
  m_fts_choose_channel_to_relay=prop.fts_choose_channel_to_relay=0;
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckProcessAllChannelsRetuneToAnyChannel() 
{
 m_fts_choose_channel_to_relay=prop.fts_choose_channel_to_relay=0;
	m_fts_relay_to_same_chann=prop.fts_relay_to_same_chann=0;
 UpdateChecks();	
}


void CFTS_MFXPropPage::OnChangeEditChannelToProcessUpTo() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
 m_fts_channel_to_process_up_to=max(1,min(MAX_MIDI_CHANNELS,m_fts_channel_to_process_up_to));
 prop.fts_channel_to_process_up_to=m_fts_channel_to_process_up_to;
 // UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckVerboseLog() 
{
 TOGGLE_AND_SET_PROP(fts_verbose_log);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnButtonShowHelp() 
{
	// TODO: Add your control notification handler code here
 ShowHelp();
}


void CFTS_MFXPropPage::OnChangeEditPitchBendDelay() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
#define MAX_MIDI_CHANNELS 16
 {
  char sz[STRMAX];
  GetDlgItemText(IDC_EDIT_PITCH_BEND_DELAY,sz,STRMAX);
  m_fts_pitch_bend_delay=atoi(sz);
 }
 prop.fts_pitch_bend_delay=m_fts_pitch_bend_delay;
 // UpdateChecks();	
}

void CFTS_MFXPropPage::OnCheckDoPitchBendDelay() 
{
	// TODO: Add your control notification handler code here
 TOGGLE_AND_SET_PROP(fts_do_pitch_bend_delay);
 UpdateChecks();	
}

void CFTS_MFXPropPage::OnDeltaposSpinChannelToRelay(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
 prop.fts_channel_to_relay+=pNMUpDown->iDelta;
 prop.fts_channel_to_relay=max(1,min(MAX_MIDI_CHANNELS,prop.fts_channel_to_relay));
 m_fts_channel_to_relay=prop.fts_channel_to_relay;
 UpdateChecks();	
	*pResult = 0;
}

void CFTS_MFXPropPage::OnDeltaposVscrollPitchBendDelay(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
 prop.fts_pitch_bend_delay-=pNMUpDown->iDelta;
 prop.fts_pitch_bend_delay=max(0,prop.fts_pitch_bend_delay);
 m_fts_pitch_bend_delay=prop.fts_pitch_bend_delay;
 UpdateChecks();	
	*pResult = 0;
}

void CFTS_MFXPropPage::OnCheckDoResetsAgain() 
{
 DECLARE_LOCAL(do_resets_again)
  do_resets_again=do_resets_again?0:1;
 prop.do_resets_again=do_resets_again;
	// TODO: Add your control notification handler code here
#ifdef cl_do_resets
 if(g_pInputPulse&&do_resets_again)
 {
  g_pInputPulse->BeginPulse();
 }
 UpdateChecks();	
#endif
}


void CFTS_MFXPropPage::OnCheckDoResets() 
{
 DECLARE_LOCAL(do_resets)
  do_resets=do_resets?0:1;
 prop.do_resets=do_resets;
	// TODO: Add your control notification handler code here
#ifdef cl_do_resets
 if(g_pInputPulse&&do_resets&&!prop.do_resets_again)
 {
  prop.do_resets_again=1;
  g_pInputPulse->BeginPulse();
 }
 UpdateChecks();	
#endif
	
}

void CFTS_MFXPropPage::OnButtonTestPitchBendRange() 
{
	// TODO: Add your control notification handler code here
 if(g_pInputPulse)
 {
  extern char do_pb_test;
  MessageBox("When you click Ok, you should  hear two notes identical in pitch.\n\n"
   "The first note is middle c, the second is B with pitch bend of + 100 cents,\n\n"
   "Do they sound identical? If so your pitch bend range is set correctly.\n\n"
   "If not, see if you can set the pitch bend range of your synth to +- 2 semitones"
   "Test pitch bend range",0
   );
  do_pb_test=1;
  g_pInputPulse->BeginPulse();
 }
	
}


void CFTS_MFXPropPage::OnButtonAllSoundOff() 
{
	// TODO: Add your control notification handler code here
	 if(g_pInputPulse)
 {
  do_all_sound_off=1;
  g_pInputPulse->BeginPulse();
 }

}

